RWTexture2D<float4> tResult : register(u0);

cbuffer SceneConstants : register( b0 )
{
    float4x4 mView;
    float4x4 mProjection;
    float4x4 mViewProjection;
    float4x4 mInvViewProjection;
    float4 vViewDir;
    float4 vViewPos;
    float4 deltas;
    float4 padd_[2];
};

Texture2D<float4> gi : register(t0);
Texture2D<float4> albedo : register(t1);

SamplerState sampl_st : register(s0);

float gaussR(float sigma, float dist)
{
	return exp(-(dist*dist)/(2.0*sigma*sigma));
}

float  gaussD(float sigma, int x, int y)
{
	return exp(-((x*x+y*y)/(2.0f*sigma*sigma)));
}

#define MINF asfloat(0xff800000)

[numthreads(8, 8, 1)]
void Composite(int3 DTid : SV_DispatchThreadID, uint groupid : SV_GroupIndex)
{
    int screen_width = 1280;
    int screen_height = 720;
    int gb_screen_width = 1600;
    int gb_screen_height = 900;
	float sigmaD=0.5f;
	float sigmaR=1.5f;
    int2 posId = int2((float(DTid.x)/float(gb_screen_width))*screen_width,
                      (float(DTid.y)/float(gb_screen_height))*screen_height);
    float3 albedo_color = lerp(float3(1,1,1),albedo[DTid.xy].rgb,albedo[DTid.xy].a);
    tResult[DTid.xy] = float4(gi[DTid.xy].rgb, 1);
}